diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
index d3bd5f73c..74e17969a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
@@ -4,7 +4,6 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
-import net.minecraft.core.world.noise.BasePerlinNoise;
 import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
@@ -12,17 +11,25 @@ public class DensityGeneratorOverworld
     implements DensityGenerator {
     private final @NotNull World world;
 
-    private final @NotNull BasePerlinNoise<?> minLimitNoise;
-    private final @NotNull BasePerlinNoise<?> maxLimitNoise;
-    private final @NotNull BasePerlinNoise<?> mainNoise;
-    private final @NotNull BasePerlinNoise<?> scaleNoise;
-    private final @NotNull BasePerlinNoise<?> depthNoise;
+    private final @NotNull PerlinNoise minLimitNoise;
+    private final @NotNull PerlinNoise maxLimitNoise;
+    private final @NotNull PerlinNoise mainNoise;
+    private final @NotNull PerlinNoise scaleNoise;
+    private final @NotNull PerlinNoise depthNoise;
 
     private final boolean generateRivers;
-    private final @NotNull BasePerlinNoise<?> smoothingRiverNoise;
-    private final @NotNull BasePerlinNoise<?> carvingRiverNoise;
-
-    protected DensityGeneratorOverworld(@NotNull World world, @NotNull BasePerlinNoise<?> minLimitNoise, @NotNull BasePerlinNoise<?> maxLimitNoise, @NotNull BasePerlinNoise<?> mainNoise, @NotNull BasePerlinNoise<?> scaleNoise, @NotNull BasePerlinNoise<?> depthNoise, boolean generateRivers) {
+    private final @NotNull PerlinNoise smoothingRiverNoise;
+    private final @NotNull PerlinNoise carvingRiverNoise;
+
+    protected DensityGeneratorOverworld(
+        @NotNull World world,
+        @NotNull PerlinNoise minLimitNoise,
+        @NotNull PerlinNoise maxLimitNoise,
+        @NotNull PerlinNoise mainNoise,
+        @NotNull PerlinNoise scaleNoise,
+        @NotNull PerlinNoise depthNoise,
+        boolean generateRivers
+    ) {
         this.world = world;
 
         this.minLimitNoise = minLimitNoise;
@@ -56,9 +63,9 @@ public class DensityGeneratorOverworld
 
         double riverLevel = 0d;
 
-        double[] largeSmoothing = this.smoothingRiverNoise.get(null, x, z, xSize, zSize, 1 / (1000d / xSize), 1 / (1000d / zSize));
-        double[] mediumSmoothing = this.smoothingRiverNoise.get(null, x, z, xSize, zSize, 1 / (50d / xSize), 1 / (50d / zSize));
-        double[] smallSmoothing = this.smoothingRiverNoise.get(null, x, z, xSize, zSize, 1 / (10d / xSize), 1 / (10d / zSize));
+        double[] largeSmoothing = this.smoothingRiverNoise.getRegion(null, x, z, xSize, zSize, 1 / (1000d / xSize), 1 / (1000d / zSize));
+        double[] mediumSmoothing = this.smoothingRiverNoise.getRegion(null, x, z, xSize, zSize, 1 / (50d / xSize), 1 / (50d / zSize));
+        double[] smallSmoothing = this.smoothingRiverNoise.getRegion(null, x, z, xSize, zSize, 1 / (10d / xSize), 1 / (10d / zSize));
 
         double[] riverRadiuses = new double[]{0.006, 0.024, 0.036};
         double[] riverMults = new double[]{20, 60, 60};
@@ -102,9 +109,9 @@ public class DensityGeneratorOverworld
 
         double riverLevel = 0d;
 
-        double[] largeCarving = this.carvingRiverNoise.get(null, x, z, xSize, zSize, 1 / (1000d / xSize), 1 / (1000d / zSize));
-        double[] mediumCarving = this.carvingRiverNoise.get(null, x, z, xSize, zSize, 1 / (50d / xSize), 1 / (50d / zSize));
-        double[] smallCarving = this.carvingRiverNoise.get(null, x, z, xSize, zSize, 1 / (10d / xSize), 1 / (10d / zSize));
+        double[] largeCarving = this.carvingRiverNoise.getRegion(null, x, z, xSize, zSize, 1 / (1000d / xSize), 1 / (1000d / zSize));
+        double[] mediumCarving = this.carvingRiverNoise.getRegion(null, x, z, xSize, zSize, 1 / (50d / xSize), 1 / (50d / zSize));
+        double[] smallCarving = this.carvingRiverNoise.getRegion(null, x, z, xSize, zSize, 1 / (10d / xSize), 1 / (10d / zSize));
 
         double[] riverRadiuses = new double[]{0.012, 0.018, 0.024};
         double[] riverMults = new double[]{20, 60, 60};
@@ -178,11 +185,11 @@ public class DensityGeneratorOverworld
         final double lowerLimitScale = 512;
 
         // uses temp and humidity to alter terrain shape.
-        double[] scaleArray = this.scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
-        double[] depthArray = this.depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
-        double[] mainNoiseArray = this.mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] scaleArray = this.scaleNoise.getRegion(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = this.depthNoise.getRegion(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
         int mainIndex = 0;
         int depthScaleIndex = 0;
         int xSizeScale = 16 / xSize;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index 1f1e751d5..45c116ed5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -9,7 +9,6 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
-import net.minecraft.core.world.noise.BasePerlinNoise;
 import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
@@ -18,13 +17,13 @@ public class SurfaceGeneratorOverworld
 {
     private final World world;
 
-    private final BasePerlinNoise<?> beachNoise;
-    private final BasePerlinNoise<?> soilNoise;
-    private final BasePerlinNoise<?> mainNoise;
+    private final PerlinNoise beachNoise;
+    private final PerlinNoise soilNoise;
+    private final PerlinNoise mainNoise;
 
     private final boolean generateStoneVariants;
 
-    protected SurfaceGeneratorOverworld(World world, BasePerlinNoise<?> beachNoise, BasePerlinNoise<?> soilNoise, BasePerlinNoise<?> mainNoise, boolean generateStoneVariants)
+    protected SurfaceGeneratorOverworld(World world, PerlinNoise beachNoise, PerlinNoise soilNoise, PerlinNoise mainNoise, boolean generateStoneVariants)
     {
         this.world = world;
         this.beachNoise = beachNoise;
@@ -59,18 +58,18 @@ public class SurfaceGeneratorOverworld
         Random rand = new Random((long) chunkX * 0x4F9939F508L + (long) chunkZ * 0x1EF1565BD5L);
 
         double beachScale = 0.03125;
-        double[] sandBeachNoise = beachNoise.get(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale, beachScale, 1.0D);
-        double[] gravelBeachNoise = beachNoise.get(null, chunkX * Chunk.CHUNK_SIZE_X, 109.0134D, chunkZ * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, 1, Chunk.CHUNK_SIZE_Z, beachScale, 1.0D, beachScale);
-        double[] soilThicknessNoise = soilNoise.get(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 2D, beachScale * 2D, beachScale * 2D);
+        double[] sandBeachNoise = beachNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale, beachScale, 1.0D);
+        double[] gravelBeachNoise = beachNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, 109.0134D, chunkZ * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, 1, Chunk.CHUNK_SIZE_Z, beachScale, 1.0D, beachScale);
+        double[] soilThicknessNoise = soilNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 2D, beachScale * 2D, beachScale * 2D);
 
         double[] stoneLayerNoise = null;
         double[] stoneLayerNoiseGranite = null;
         double[] stoneLayerNoiseLimestone = null;
         if (generateStoneVariants)
         {
-            stoneLayerNoise = soilNoise.get(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
-            stoneLayerNoiseGranite = mainNoise.get(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
-            stoneLayerNoiseLimestone = beachNoise.get(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
+            stoneLayerNoise = soilNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
+            stoneLayerNoiseGranite = mainNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
+            stoneLayerNoiseLimestone = beachNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
         }
 
         for(int z = 0; z < Chunk.CHUNK_SIZE_Z; z++)
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
index 343f4fafb..973d8438e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -8,6 +8,7 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
+import net.minecraft.core.world.noise.LegacyNoiseType;
 import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
@@ -21,7 +22,7 @@ public class ChunkDecoratorOverworldB173
     public ChunkDecoratorOverworldB173(final @NotNull World world) {
         this.world = world;
 
-        this.forestNoise = new PerlinNoise(world.getRandomSeed(), 8, 82);
+        this.forestNoise = new PerlinNoise(world.getRandomSeed(), 8, 82, LegacyNoiseType.BETA);
     }
 
     @Override
@@ -135,7 +136,7 @@ public class ChunkDecoratorOverworldB173
         }
 
         final double forestNoiseScale = 0.5;
-        final int forestNoiseValue = (int) ((this.forestNoise.get(wx * forestNoiseScale, wz * forestNoiseScale) / 8.0 + rand.nextDouble() * 4.0 + 4.0) / 3.0);
+        final int forestNoiseValue = (int) ((this.forestNoise.getValue(wx * forestNoiseScale, wz * forestNoiseScale) / 8.0 + rand.nextDouble() * 4.0 + 4.0) / 3.0);
         int numTrees = 0;
 
         if (rand.nextInt(10) == 0) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
index c212cec53..49b398e2b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
@@ -2,7 +2,8 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.DensityGeneratorOverworld;
-import net.minecraft.core.world.noise.BetaPerlinNoise;
+import net.minecraft.core.world.noise.LegacyNoiseType;
+import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class DensityGeneratorOverworldB173
@@ -10,11 +11,11 @@ public class DensityGeneratorOverworldB173
 
     public DensityGeneratorOverworldB173(final @NotNull World world) {
         super(world,
-            new BetaPerlinNoise(world.getRandomSeed(), 16, 0),
-            new BetaPerlinNoise(world.getRandomSeed(), 16, 16),
-            new BetaPerlinNoise(world.getRandomSeed(), 8, 32),
-            new BetaPerlinNoise(world.getRandomSeed(), 10, 48),
-            new BetaPerlinNoise(world.getRandomSeed(), 16, 58),
+            new PerlinNoise(world.getRandomSeed(), 16, 0, LegacyNoiseType.BETA),
+            new PerlinNoise(world.getRandomSeed(), 16, 16, LegacyNoiseType.BETA),
+            new PerlinNoise(world.getRandomSeed(), 8, 32, LegacyNoiseType.BETA),
+            new PerlinNoise(world.getRandomSeed(), 10, 48, LegacyNoiseType.BETA),
+            new PerlinNoise(world.getRandomSeed(), 16, 58, LegacyNoiseType.BETA),
             false
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java
index 96efed91b..add4478aa 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java
@@ -2,16 +2,17 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
-import net.minecraft.core.world.noise.BetaPerlinNoise;
+import net.minecraft.core.world.noise.LegacyNoiseType;
+import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class SurfaceGeneratorOverworldB173
     extends SurfaceGeneratorOverworld {
     public SurfaceGeneratorOverworldB173(final @NotNull World world) {
         super(world,
-            new BetaPerlinNoise(world.getRandomSeed(), 4, 40),
-            new BetaPerlinNoise(world.getRandomSeed(), 4, 44),
-            new BetaPerlinNoise(world.getRandomSeed(), 8, 32),
+            new PerlinNoise(world.getRandomSeed(), 4, 40, LegacyNoiseType.BETA),
+            new PerlinNoise(world.getRandomSeed(), 4, 44, LegacyNoiseType.BETA),
+            new PerlinNoise(world.getRandomSeed(), 8, 32, LegacyNoiseType.BETA),
             false
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
index a0888acfb..493abff0f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
@@ -6,11 +6,9 @@ import net.minecraft.core.block.BlockLogicOreGold;
 import net.minecraft.core.block.BlockLogicOreIron;
 import net.minecraft.core.block.BlockLogicOreLapis;
 import net.minecraft.core.block.BlockLogicOreRedstone;
-import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.chunk.ChunkFeatureDecorator;
 import net.minecraft.core.world.generate.feature.*;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
@@ -18,8 +16,6 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
-import java.util.Random;
-
 public class ChunkDecoratorOverworldHell
     extends ChunkFeatureDecorator {
     private final @NotNull PerlinNoise treeDensityNoise;
@@ -179,7 +175,7 @@ public class ChunkDecoratorOverworldHell
 
         this.register(14, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
             final double d = 0.5D;
-            int treeDensity = (int) ((this.treeDensityNoise.get((double) worldX * d, (double) worldZ * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
+            int treeDensity = (int) ((this.treeDensityNoise.getValue((double) worldX * d, (double) worldZ * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
             if (rand.nextInt(10) == 0) {
                 treeDensity++;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
index ab9769f6e..fa68e82fa 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
@@ -14,7 +14,8 @@ import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
-import net.minecraft.core.world.noise.RetroPerlinNoise;
+import net.minecraft.core.world.noise.LegacyNoiseType;
+import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -22,14 +23,14 @@ import java.util.Random;
 public class ChunkDecoratorOverworldRetro
     implements ChunkDecorator {
     private final @NotNull World world;
-    private final @NotNull RetroPerlinNoise treeDensityNoise;
+    private final @NotNull PerlinNoise treeDensityNoise;
 
     private final boolean snowCovered;
 
     public ChunkDecoratorOverworldRetro(@NotNull World world) {
         this.world = world;
 
-        this.treeDensityNoise = new RetroPerlinNoise(world.getRandomSeed(), 8, 74);
+        this.treeDensityNoise = new PerlinNoise(world.getRandomSeed(), 8, 74, LegacyNoiseType.ALPHA);
 
         this.snowCovered = false;//new Random(world.getRandomSeed()).nextBoolean();
     }
@@ -115,7 +116,7 @@ public class ChunkDecoratorOverworldRetro
         }
 
         double d = 0.5D;
-        int l3 = (int) ((this.treeDensityNoise.get((double) k * d, (double) l * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
+        int l3 = (int) ((this.treeDensityNoise.getValue((double) k * d, (double) l * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
         if (l3 < 0) {
             l3 = 0;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
index 746c7b494..e7f96ccc2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
@@ -2,18 +2,19 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.retro;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.DensityGeneratorOverworld;
-import net.minecraft.core.world.noise.RetroPerlinNoise;
+import net.minecraft.core.world.noise.LegacyNoiseType;
+import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class DensityGeneratorOverworldRetro
     extends DensityGeneratorOverworld {
     public DensityGeneratorOverworldRetro(@NotNull World world) {
         super(world,
-            new RetroPerlinNoise(world.getRandomSeed(), 16, 0),
-            new RetroPerlinNoise(world.getRandomSeed(), 16, 16),
-            new RetroPerlinNoise(world.getRandomSeed(), 8, 32),
-            new RetroPerlinNoise(world.getRandomSeed(), 10, 48),
-            new RetroPerlinNoise(world.getRandomSeed(), 16, 58),
+            new PerlinNoise(world.getRandomSeed(), 16, 0, LegacyNoiseType.ALPHA),
+            new PerlinNoise(world.getRandomSeed(), 16, 16, LegacyNoiseType.ALPHA),
+            new PerlinNoise(world.getRandomSeed(), 8, 32, LegacyNoiseType.ALPHA),
+            new PerlinNoise(world.getRandomSeed(), 10, 48, LegacyNoiseType.ALPHA),
+            new PerlinNoise(world.getRandomSeed(), 16, 58, LegacyNoiseType.ALPHA),
             false
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/SurfaceGeneratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/SurfaceGeneratorOverworldRetro.java
index 6af246763..ec1e983d9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/SurfaceGeneratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/SurfaceGeneratorOverworldRetro.java
@@ -2,16 +2,17 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.retro;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
-import net.minecraft.core.world.noise.RetroPerlinNoise;
+import net.minecraft.core.world.noise.LegacyNoiseType;
+import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class SurfaceGeneratorOverworldRetro
     extends SurfaceGeneratorOverworld {
     public SurfaceGeneratorOverworldRetro(@NotNull World world) {
         super(world,
-            new RetroPerlinNoise(world.getRandomSeed(), 4, 40),
-            new RetroPerlinNoise(world.getRandomSeed(), 4, 44),
-            new RetroPerlinNoise(world.getRandomSeed(), 8, 32),
+            new PerlinNoise(world.getRandomSeed(), 4, 40, LegacyNoiseType.ALPHA),
+            new PerlinNoise(world.getRandomSeed(), 4, 44, LegacyNoiseType.ALPHA),
+            new PerlinNoise(world.getRandomSeed(), 8, 32, LegacyNoiseType.ALPHA),
             false
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/CombinedPerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/CombinedPerlinNoise.java
index 6a0c3618b..b71b4b2ab 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/CombinedPerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/CombinedPerlinNoise.java
@@ -1,17 +1,17 @@
 package net.minecraft.core.world.noise;
 
-public class CombinedPerlinNoise
-{
-    private final BasePerlinNoise<?> perlinNoiseA;
-    private final BasePerlinNoise<?> perlinNoiseB;
+import org.jetbrains.annotations.NotNull;
 
-    public CombinedPerlinNoise(BasePerlinNoise<?> perlinNoiseA, BasePerlinNoise<?> perlinNoiseB) {
+public class CombinedPerlinNoise {
+    private final @NotNull PerlinNoise perlinNoiseA;
+    private final @NotNull PerlinNoise perlinNoiseB;
+
+    public CombinedPerlinNoise(final @NotNull PerlinNoise perlinNoiseA, final @NotNull PerlinNoise perlinNoiseB) {
         this.perlinNoiseA = perlinNoiseA;
         this.perlinNoiseB = perlinNoiseB;
     }
 
-    public double get(double x, double y)
-    {
-        return this.perlinNoiseA.get(x + this.perlinNoiseB.get(x, y), y);
+    public double get(final double x, final double y) {
+        return this.perlinNoiseA.getValue(x + this.perlinNoiseB.getValue(x, y), y);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/SurfaceNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/FractalBrownianNoise.java
similarity index 53%
rename from game/core/src/main/java/net/minecraft/core/world/noise/SurfaceNoise.java
rename to game/core/src/main/java/net/minecraft/core/world/noise/FractalBrownianNoise.java
index 584e4cf8f..90db48580 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/SurfaceNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/FractalBrownianNoise.java
@@ -1,5 +1,4 @@
 package net.minecraft.core.world.noise;
 
-public abstract class SurfaceNoise
-{
+public class FractalBrownianNoise {
 }
